﻿namespace HeuristicLab.Problems.ProgramSynthesis {
  using System;

  public class PooledObject<T> : IDisposable, IPooledObject
    where T : class {

    private readonly ObjectPool<PooledObject<T>> pool;
    private readonly T item;
    private readonly Action<T> resetor;

    public PooledObject(ObjectPool<PooledObject<T>> pool, T item, Action<T> resetor) {
      this.pool = pool;
      this.item = item;
      this.resetor = resetor;
    }

    public virtual void Dispose() {
      resetor(item);
      pool.Free(this);
    }

    public void Reset() {
      resetor(item);
    }
  }
}
